#include <stdio.h>
#include "dyncom.h"
#include "dynlib.h"


static DCM *_dynlist[64];
static int _dynlistcount = 0;

static void *_dynExternVarHandler(int var);
static void *_dynExternProcHandler(int proc);

static void *(*_dynInternVarHandler)(int var)=NULL;
static void *(*_dynInternProcHandler)(int proc)=NULL;


void dynClearList(void)
{
  int index;

  for (index=0; index<_dynlistcount; index++)
      { Free_DCM(_dynlist[index]); }

  memset(&_dynlist[0], 0, 256);
}

int dynLoadDCM(char *filename)
{
  _dynlist[_dynlistcount]=Load_DCM(filename, _dynExternProcHandler, _dynExternVarHandler);

  if (!(_dynlist[_dynlistcount]))
     { return DYN_FALSE; }

  _dynlistcount++;

  return ((_dynlistcount)*1000);
}

void dynQuit(void)
{
  dynClearList();
}

void dynSetVarHandler(void *var)
{
  _dynInternVarHandler=var;
}

void dynSetProcHandler(void *proc)
{
  _dynInternProcHandler=proc;
}

void *dynGetVar(int var)
{
  return(_dynExternVarHandler(var));
}

void *dynGetProc(int proc)
{
  return(_dynExternProcHandler(proc));
}

void *_dynExternVarHandler(int var)
{
  int v, f;

  v=var%1000;
  f=var/1000;

  if (f==0)
     {
       if (_dynInternVarHandler)
          return(_dynInternVarHandler(v));
     }
  else if (_dynlist[f-1])
     return(_dynlist[f-1]->dcm_var(_dynlist[f-1], v));
  return 0;
}

void *_dynExternProcHandler(int proc)
{
  int p, f;

  p=proc%1000;
  f=proc/1000;

  if (f==0)
     {
       if (_dynInternProcHandler)
          return(_dynInternProcHandler(p));
     }
  else if (_dynlist[f-1])
     return(_dynlist[f-1]->dcm_proc(_dynlist[f-1], p));
  return 0;
}
